



import numpy as np
import matplotlib.pyplot as plt



default_font_size = plt.rcParams['font.size']

plt.rcParams['font.size'] = default_font_size*1.5



old_new_id = np.loadtxt('stripes_data_0_spikes_ROI_old_newid.csv', skiprows=1, delimiter=',')[:,0:2].astype(int)


J_ij_MLE = np.loadtxt('stripes_0_J_est_MLE.txt')
J_ij_ML2 = np.loadtxt('stripes_0_J_est_ML-II.txt')
J_ij_MAP = np.loadtxt('stripes_0_J_est_MAP.txt')
J_ij_true = np.loadtxt('stripes_data_0_W.csv', delimiter=',')[old_new_id[:,0]][:,old_new_id[:,0]]

# J_ij_ML2 = J_ij_MAP
GTE_ij = np.loadtxt('stripes_0_GTE.csv',delimiter=',')[old_new_id[:,0]][:,old_new_id[:,0]]

J_ij_ML2[np.diag_indices_from(J_ij_ML2)] = 0
J_ij_MAP[np.diag_indices_from(J_ij_MAP)] = 0
J_ij_true[np.diag_indices_from(J_ij_true)] = 0

W = np.copy(J_ij_true)
W[W!=0]=1
plt.hist(W.sum(axis=0))

# plt.hist(J_ij_true.flatten())
plt.matshow(J_ij_true, vmin=-np.max(np.abs(J_ij_true)), vmax=np.max(np.abs(J_ij_true)),cmap='RdBu')

plt.close()

plt.matshow(J_ij_ML2, vmin=-np.max(np.abs(J_ij_ML2)), vmax=np.max(np.abs(J_ij_ML2)) ,cmap='RdBu')
plt.close()

plt.matshow(J_ij_MAP, vmin=-np.max(np.abs(J_ij_MAP)), vmax=np.max(np.abs(J_ij_MAP)) ,cmap='RdBu')
plt.close()




def get_state(J_ij):
    neural_state = np.zeros(len(J_ij), dtype=np.int8)

    for i in range(len(J_ij)):
        if not np.all(J_ij[:,i]==0):
            if np.all(J_ij[:,i]>=0):
                neural_state[i] = 1
            else:
                 if np.all(J_ij[:,i]<=0):
                    neural_state[i] = -1
        else:
            randtmp = np.random.rand()
            neural_state[i] = 1
            # if randtmp>0.8:
            #     neural_state[i] = -1
            # else:
            #     neural_state[i] = 1
    return neural_state




state_ML2 = get_state(J_ij_ML2)
state_MAP = get_state(J_ij_MAP)
state_true = get_state(J_ij_true)

#
# # only get non_zero_states
# screen = (state_MAP!=0)
# J_ij_ML2 = J_ij_ML2[screen,:][:,screen]
# J_ij_MAP = J_ij_MAP[screen,:][:,screen]
# J_ij_true = J_ij_true[screen,:][:,screen]
# GTE_ij = GTE_ij[screen,:][:,screen]
# state_ML2 = get_state(J_ij_ML2)
# state_MAP = get_state(J_ij_MAP)
# state_true = get_state(J_ij_true)




# state_true[144] = -1

P_true_excit = (state_true == 1).sum() / len(state_true)
P_true_inhib = (state_true == -1).sum() / len(state_true)

print('ML2')


TPR =  (( J_ij_true[J_ij_ML2==0] == 0).sum() - len(J_ij_ML2)) / ((J_ij_true==0).sum() - len(J_ij_ML2) )
FPR =  ( ( J_ij_true[J_ij_ML2==0] != 0).sum() ) / ((J_ij_true!=0).sum() )
print('TPR, FPR rate for finding zero links:',TPR, FPR)

TPR =  (( J_ij_true[J_ij_ML2==0] == 0).sum() - len(J_ij_ML2)) / ((J_ij_ML2==0).sum() - len(J_ij_ML2))
FPR =  ( ( J_ij_true[J_ij_ML2==0] != 0).sum() ) / ((J_ij_ML2==0).sum() - len(J_ij_ML2))
print('predictability rate for finding zero links:',TPR, FPR)




TPR =  (( J_ij_true[J_ij_ML2!=0] != 0).sum() ) / ((J_ij_true!=0).sum()  )
FPR =   ( ( J_ij_true[J_ij_ML2!=0] == 0).sum() ) / ((J_ij_true==0).sum()-len(J_ij_true) )
print('TPR, FPR rate for finding non-zero links:',TPR, FPR)
TPR_TFR_non_zero_ML2 = [TPR, FPR]

ML2TPR = TPR
ML2FPR = FPR


TPR =  (( J_ij_true[J_ij_ML2!=0] != 0).sum() ) / ((J_ij_ML2!=0).sum()  )
FPR =   ( ( J_ij_true[J_ij_ML2!=0] == 0).sum() ) / ((J_ij_ML2!=0).sum()  )
print('predictability rate for finding non-zero links:',TPR, FPR)




P_g_t_con = np.zeros((2,2))
for i in range(len(state_true)):
    P_g_t_con[ (state_true[i]+1)//2, (state_ML2[i]+1)//2 ] += 1
print('overall rate neuon types:', (P_g_t_con[0,0]+P_g_t_con[1,1])/len(state_true) )
print('predictability of inhib:', P_g_t_con[0,0]/P_g_t_con[:,0].sum())
print('predictability of excit:', P_g_t_con[1,1]/P_g_t_con[:,1].sum())

P_g_t_con = np.zeros((2,2))
for i in range(len(state_true)):
    P_g_t_con[ (state_ML2[i]+1)//2, (state_true[i]+1)//2 ] += 1
P_g_t_con[:,0] /= P_g_t_con[:,0].sum()
P_g_t_con[:,1] /= P_g_t_con[:,1].sum()
print('overall TPR rate neuon types:', P_g_t_con[0,0]*P_true_inhib + P_g_t_con[1,1]*P_true_excit )
print('overall FPR rate neuon types:', P_g_t_con[1,0]*P_true_inhib + P_g_t_con[0,1]*P_true_excit )
print('TPR, FPR of inhib:', P_g_t_con[0,0], P_g_t_con[0,1])
print('TPR, FPR of excit:', P_g_t_con[1,1], P_g_t_con[1,0])


P_g_t_con = np.zeros((3,3))
for i in range(len(state_true)):
    for j in range(len(state_true)):
        if i != j:
            inttmp = 1
            if J_ij_ML2[i,j] > 0:
                inttmp = 2
            else:
                if J_ij_ML2[i,j] < 0:
                    inttmp = 0
            inttmp1 = 1
            if J_ij_true[i,j] > 0:
                inttmp1 = 2
            else:
                if J_ij_true[i,j] < 0:
                    inttmp1 = 0
            P_g_t_con[inttmp, inttmp1] += 1

P_g_t_con.astype(int)









print("MAP")

TPR =  (( J_ij_true[J_ij_MAP==0] == 0).sum() - len(J_ij_MAP)) / ((J_ij_true==0).sum() - len(J_ij_MAP) )
FPR =  ( ( J_ij_true[J_ij_MAP==0] != 0).sum() ) / ((J_ij_true!=0).sum() )
print('TPR, FPR rate for finding zero links:',TPR, FPR)
TPR =  (( J_ij_true[J_ij_MAP==0] == 0).sum() - len(J_ij_MAP)) / ((J_ij_MAP==0).sum() - len(J_ij_ML2))
FPR =  ( ( J_ij_true[J_ij_MAP==0] != 0).sum() ) / ((J_ij_MAP==0).sum() )
print('predictability rate for finding zero links:',TPR, FPR)

TPR =  (( J_ij_true[J_ij_MAP!=0] != 0).sum() ) / ((J_ij_true!=0).sum()  )
FPR =   ( ( J_ij_true[J_ij_MAP!=0] == 0).sum() ) / ((J_ij_true==0).sum()-len(J_ij_true) )
print('TPR, FPR rate for finding non-zero links:',TPR, FPR)
TPR_TFR_non_zero_MAP = [TPR, FPR]


TPR =  (( J_ij_true[J_ij_MAP!=0] != 0).sum() ) / ((J_ij_MAP!=0).sum()  )
FPR =   ( ( J_ij_true[J_ij_MAP!=0] == 0).sum() ) / ((J_ij_MAP!=0).sum()  )
print('predictability rate for finding non-zero links:',TPR, FPR)

P_g_t_con = np.zeros((2,2))
for i in range(len(state_true)):
    P_g_t_con[ (state_true[i]+1)//2, (state_MAP[i]+1)//2 ] += 1
print('overall rate neuon types:', (P_g_t_con[0,0]+P_g_t_con[1,1])/len(state_true) )
print('predictability of inhib:', P_g_t_con[0,0]/P_g_t_con[:,0].sum())
print('predictability of excit:', P_g_t_con[1,1]/P_g_t_con[:,1].sum())


P_g_t_con = np.zeros((2,2))
for i in range(len(state_true)):
    P_g_t_con[ (state_MAP[i]+1)//2, (state_true[i]+1)//2 ] += 1
P_g_t_con[:,0] /= P_g_t_con[:,0].sum()
P_g_t_con[:,1] /= P_g_t_con[:,1].sum()

print('overall TPR rate neuon types:', P_g_t_con[0,0]*P_true_inhib + P_g_t_con[1,1]*P_true_excit )
print('overall FPR rate neuon types:', P_g_t_con[1,0]*P_true_inhib + P_g_t_con[0,1]*P_true_excit )
print('TPR, FPR of inhib:', P_g_t_con[0,0], P_g_t_con[0,1])
print('TPR, FPR of excit:', P_g_t_con[1,1], P_g_t_con[1,0])










def TPR_TFR_zero(GTE, W):
    TPR = ( (W[GTE==0] == 0).sum() - len(W) )/( (W==0).sum() - len(W) )
    FPR = ( (W[GTE==0] != 0).sum() )/( (W!=0).sum() )
    return np.array([TPR, FPR])
#
#
# def TPR_TFR_zero(GTE, W):
#     TPR = ( (W[GTE==0] == 0).sum() - len(GTE) )/( (GTE==0).sum() - len(GTE) )
#     FPR = ( (W[GTE==0] != 0).sum() )/( (GTE==0).sum() - len(GTE) )
#     return np.array([TPR, FPR])


def TPR_TFR_non_zero(GTE, W):
    TPR = ( (W[GTE!=0] != 0).sum() )/( (W!=0).sum() )
    FPR = ( (W[GTE!=0] == 0).sum() )/( (W==0).sum() - len(W))
    return np.array([TPR, FPR])
#
#
# def TPR_TFR_non_zero(GTE, W):
#     TPR = ( (W[GTE!=0] != 0).sum() )/( (GTE!=0).sum() )
#     FPR = ( (W[GTE!=0] == 0).sum() )/( (GTE!=0).sum() )
#     return np.array([TPR, FPR])


GTE = GTE_ij
W = J_ij_true

GTE_mu = GTE.mean()
GTE_sd = GTE.std()
GTE_Z = (GTE-GTE_mu)/GTE_sd

# plt.matshow(GTE[:, old_new_id.T[0]][old_new_id.T[0], :] )
# plt.matshow(W[:, old_new_id.T[0]][old_new_id.T[0], :] )

z_threshold = np.arange(GTE_Z.min(), GTE_Z.max(), (GTE_Z.max()-GTE_Z.min())/1000)

# np.unique(GTE_Z)

ROC_zero = np.zeros((len(z_threshold) ,3))
ROC_nonzero = np.zeros((len(z_threshold) ,3))

for i in range(len(z_threshold)):
    threshold = z_threshold[i]
    GTE_Z_t = np.copy(GTE_Z)
    GTE_Z_t[GTE_Z_t<threshold] = 0

    ROC_zero[i, 0] = threshold
    ROC_zero[i, 1:] = TPR_TFR_zero(GTE_Z_t, W)

    ROC_nonzero[i, 0] = threshold
    ROC_nonzero[i, 1:] = TPR_TFR_non_zero(GTE_Z_t, W)



s = 70
plt.close()
fig, ax = plt.subplots()

ax.plot([0, 1], [0, 1], color='k', linestyle='--',dashes=(20, 20), linewidth=0.5)
ax.plot(ROC_nonzero.T[2], ROC_nonzero.T[1], linewidth=2, c = '#0000ff', label='GTE')
ax.scatter( [TPR_TFR_non_zero_MAP[1]], [TPR_TFR_non_zero_MAP[0]], marker='o', s=s, facecolors='none', edgecolors='#00ff00', label='MAP')
ax.scatter( [TPR_TFR_non_zero_ML2[1]], [TPR_TFR_non_zero_ML2[0]], marker='o', s=s, facecolors='none', edgecolors='#ff0000', label='GML')
ax.set_xlim((0,1))
ax.set_ylim((0,1))
ax.set_xlabel(r'FPR', labelpad=1)
ax.set_ylabel(r'TPR', labelpad=-2)
legend = ax.legend(loc='lower right')
fig = plt.gcf()
fig.set_size_inches(6, 3)
plt.savefig('fig_in_vitro_ROC_zero.pdf', bbox_inches='tight', transparent=True)
plt.show()
plt.close()




# ML2TPR
# ML2FPR


print(ROC_nonzero[ ROC_nonzero[:,2] > ML2FPR, :][-1,:])










plot_id = np.ones((len(J_ij_true),len(J_ij_true)), dtype=bool)

# plot_id = np.where(J_ij_true!=0)

plot_id = (J_ij_true<0)

abs_wij=np.copy(J_ij_true[plot_id]).flatten()
abs_wij=(abs_wij-abs_wij.min())/(abs_wij.max()-abs_wij.min())

abs_Jij=(np.copy(J_ij_ML2[plot_id]).flatten())
abs_Jij=(abs_Jij-abs_Jij.min())/(abs_Jij.max()-abs_Jij.min())


abs_GTE=np.copy(GTE_ij[plot_id]).flatten()
abs_GTE=(abs_GTE-abs_GTE.min())/(abs_GTE.max()-abs_GTE.min())


import pandas as pd
import matplotlib.pyplot as plt
import numpy as np
from scipy.stats import linregress


# Create a DataFrame from the data
data = {'x': abs_wij, 'y': abs_Jij, 'z': abs_GTE}
df = pd.DataFrame(data)

# Perform regression using numpy
coefficients = np.polyfit(df['x'], df['y'], 1)
regression_line = np.poly1d(coefficients)

# Perform regression using numpy
coefficients_gte = np.polyfit(df['x'], df['z'], 1)
regression_line_gte = np.poly1d(coefficients_gte)


# Calculate R-squared value
y_mean = np.mean(df['y'])
ss_total = np.sum((df['y'] - y_mean) ** 2)
ss_residual = np.sum((df['y'] - regression_line(df['x'])) ** 2)
r_squared = 1 - (ss_residual / ss_total)

# Calculate R-squared value
y_mean_gte = np.mean(df['y'])
ss_total_gte = np.sum((df['z'] - y_mean) ** 2)
ss_residual_gte = np.sum((df['z'] - regression_line(df['x'])) ** 2)
r_squared_gte = 1 - (ss_residual_gte / ss_total_gte)


# # Perform regression using scipy (simple linear regression)
# slope, intercept, r_value, p_value, std_err = linregress(df['x'], df['y'])
# regression_line = lambda x: slope * x + intercept

# Plot the data and regression line
plt.scatter(df['x'], df['y'], label='Data points', color='blue', s=1)
plt.plot(df['x'], regression_line(df['x']), color='blue', label='Regression line')

plt.scatter(df['x'], df['z'], label='Data points', color='green', s=1)
plt.plot(df['x'], regression_line_gte(df['x']), color='green', label='Regression line')

plt.xlabel('x')
plt.ylabel('y')
plt.legend()
plt.title('Regression Plot')
plt.grid(True)
plt.show()
plt.close()

print(coefficients, r_squared)
print(coefficients_gte, r_squared_gte)




import numpy as np

# Assuming you have two arrays 'array1' and 'array2'
array1 = np.abs(J_ij_true).flatten()

array2 = np.abs(J_ij_ML2).flatten()
# for i,v in enumerate(array2):
#     if v>0:
#         array2[i] = np.log(np.abs(v))
#     if v<0:
#         array2[i] = np.log(np.abs(v))

# Calculate the correlation coefficient
correlation_coefficient = np.corrcoef(array1, array2)[0, 1]

print("Correlation coefficient:", correlation_coefficient)


import numpy as np

# Assuming you have two arrays 'array1' and 'array2'
array1 = np.abs(J_ij_true).flatten()
array3 = GTE_ij.flatten()

# Calculate the correlation coefficient
correlation_coefficient = np.corrcoef(array1, array3)[0, 1]

print("Correlation coefficient:", correlation_coefficient)








import numpy as np
import matplotlib.pyplot as plt
from sklearn.cluster import KMeans
from matplotlib.patches import Ellipse


import matplotlib.ticker

class OOMFormatter(matplotlib.ticker.ScalarFormatter):
    def __init__(self, order=0, fformat="%1.1f", offset=True, mathText=True):
        self.oom = order
        self.fformat = fformat
        matplotlib.ticker.ScalarFormatter.__init__(self,useOffset=offset,useMathText=mathText)
    def _set_order_of_magnitude(self):
        self.orderOfMagnitude = self.oom
    def _set_format(self, vmin=None, vmax=None):
        self.format = self.fformat
        if self._useMathText:
            self.format = r'$\mathdefault{%s}$' % self.format


plt.close()
# Step 1: Create your 1D arrays x and y.
x = np.copy(J_ij_true.flatten())
y = np.copy(GTE_ij.flatten())

# Step 2: Combine the arrays x and y into a 2D array.
data = np.column_stack((x, y))

# Step 3: Perform k-means clustering.
num_clusters = 3  # You can set this to the desired number of clusters
kmeans = KMeans(n_clusters=num_clusters)
kmeans.fit(data)

# Step 4: Get the cluster centers, covariance matrices, and standard deviations for each cluster.
cluster_centers = kmeans.cluster_centers_
cluster_labels = kmeans.labels_
cluster_std = []
cov_matrices = []


# Define the new desired order of cluster labels (e.g., [2, 0, 1])
new_order = np.argsort(cluster_centers[:,0])  # Replace this with your desired order

# Create a mapping of original cluster labels to new order
mapping = {old_label: new_label for new_label, old_label in enumerate(new_order)}

# Rearrange cluster_labels and cluster_centers according to the new order
cluster_labels = np.array([mapping[label] for label in cluster_labels])
cluster_centers = cluster_centers[new_order]

# Compute covariance matrices and standard deviations
for i in range(num_clusters):
    cluster_data = data[cluster_labels == i]
    cov_matrices.append(np.cov(cluster_data.T))
    cluster_std.append(np.std(cluster_data, axis=0))


# Step 5: Plot the data points and cluster centers with ellipses.
fig, ax = plt.subplots( )
ax.scatter(data[:, 0], data[:, 1], c=cluster_labels, cmap='coolwarm', s=1)
ax.scatter(cluster_centers[:, 0], cluster_centers[:, 1], c='k', marker='x', s=100)

cluster_centers_annotation = np.copy(cluster_centers)
cluster_centers_annotation[0] += np.array([+3.3, 0])
cluster_centers_annotation[1] += np.array([-2.7, 0])
cluster_centers_annotation[2] += np.array([-2.8, 0])

for i in range(num_clusters):
    eigenvalues, eigenvectors = np.linalg.eigh(cov_matrices[i])
    ellipse = Ellipse(cluster_centers[i], 3 * cluster_std[i][0], 3 * cluster_std[i][1],
                      edgecolor='k', fill=False, linestyle='dotted')
    ax.add_artist(ellipse)
    annotation = fr'({cluster_centers[i][0]:.0f}, {cluster_centers[i][1]*(10**4):.1f}$\times 10^{{-4}}$)'
    ax.annotate(annotation, cluster_centers_annotation[i], textcoords="offset points", xytext=(0, 10),
                ha='center', fontsize=11, color='k')

ax.set_xlabel(r'$W_{ij}$')
ax.set_ylabel(r'GTE$_{ij}$')
ax.yaxis.set_major_formatter(OOMFormatter(-4, "%1.1f"))
ax.ticklabel_format(axis='y', style='sci', scilimits=(-4,-4))
ax.set_xticks(np.arange(-14,8,2))
ax.set_xlim(-14,8)
plt.tight_layout()
fig.set_size_inches(6, 3.23)
plt.savefig('fig_in_silico_W_GTE.png', bbox_inches='tight', transparent=True)
plt.show()





# J_ij_ML2 = J_ij_MAP

import numpy as np
import matplotlib.pyplot as plt
from sklearn.cluster import KMeans
from matplotlib.patches import Ellipse

plt.close()
# Step 1: Create your 1D arrays x and y.
x = np.copy(J_ij_true.flatten())
y = np.copy(J_ij_ML2.flatten())

# Step 2: Combine the arrays x and y into a 2D array.
data = np.column_stack((x, y))

# Step 3: Perform k-means clustering.
num_clusters = 3  # You can set this to the desired number of clusters
kmeans = KMeans(n_clusters=num_clusters)
kmeans.fit(data)

# Step 4: Get the cluster centers, covariance matrices, and standard deviations for each cluster.
cluster_centers = kmeans.cluster_centers_
cluster_labels = kmeans.labels_
cluster_std = []
cov_matrices = []


# Define the new desired order of cluster labels (e.g., [2, 0, 1])
new_order = np.argsort(cluster_centers[:,0])  # Replace this with your desired order

# Create a mapping of original cluster labels to new order
mapping = {old_label: new_label for new_label, old_label in enumerate(new_order)}

# Rearrange cluster_labels and cluster_centers according to the new order
cluster_labels = np.array([mapping[label] for label in cluster_labels])
cluster_centers = cluster_centers[new_order]

# Compute covariance matrices and standard deviations
for i in range(num_clusters):
    cluster_data = data[cluster_labels == i]
    cov_matrices.append(np.cov(cluster_data.T))
    cluster_std.append(np.std(cluster_data, axis=0))


# Step 5: Plot the data points and cluster centers with ellipses.
fig, ax = plt.subplots( )
ax.scatter(data[:, 0], data[:, 1], c=cluster_labels, cmap='coolwarm', s=1)
ax.scatter(cluster_centers[:, 0], cluster_centers[:, 1], c='k', marker='x', s=100)

cluster_centers_annotation = np.copy(cluster_centers)
cluster_centers_annotation[0] += np.array([+3.3, 0])
cluster_centers_annotation[1] += np.array([-2.7, 0])
cluster_centers_annotation[2] += np.array([-2.8, 0])

for i in range(num_clusters):
    eigenvalues, eigenvectors = np.linalg.eigh(cov_matrices[i])
    ellipse = Ellipse(cluster_centers[i], 3 * cluster_std[i][0], 3 * cluster_std[i][1],
                      edgecolor='k', fill=False, linestyle='dotted')
    ax.add_artist(ellipse)
    annotation = f'({cluster_centers[i][0]:.0f}, {cluster_centers[i][1]:.2f})'
    ax.annotate(annotation, cluster_centers_annotation[i], textcoords="offset points", xytext=(0, 10),
                ha='center', fontsize=12, color='k')

ax.set_xlabel(r'$W_{ij}$')
ax.set_ylabel(r'J$_{ij}$')
ax.set_xticks(np.arange(-14,8,2))
ax.set_xlim(-14,8)
plt.tight_layout()
fig.set_size_inches(6, 3)
plt.savefig('fig_in_silico_W_J.png', bbox_inches='tight', transparent=True)
plt.show()



plt.hist(J_ij_ML2[J_ij_ML2!=0].flatten(),bins=100)



J_ij_ML2[J_ij_ML2<0].mean()






len(J_ij_ML2)




#
